extern puts
 
global main
 
section .data
  call_denied_str: db 'call denied!',0
  no_args_str: db 'no args',0
  works_str: db 'WORKS',0
  failed_str: db 'FAILED',0
section .text
main:
  push ebp
  mov ebp, esp

  ; Verify at least one argument is given
  mov ebx, [ebp + 8] ; [ebp + 8] = argc
  cmp ebx, 1
  jg args

  ; If no argument is given print an error message
  push no_args_str
  call puts
  add esp, 4
  jmp end

args:

  mov ebx, [ebp + 12]  ; Get argv = [ebp +12]
  mov eax, [ebx + 4]   ; Get argv[1]
  mov al, [eax]        ; Get first char
  cmp al , '.'         ; Compare first char with dot
  jnz no_dot

  ; First char is dot
  push failed_str      ; Push address of failed string
  call puts            ; Call puts
  add esp, 4           ; Clear stack

  push call_denied_str ; Push address of call denied
  call puts            ; Call puts
  add esp, 4           ; Clear stack

  jmp end
no_dot:
  push works_str       ; Push address of works string
  call puts            ; Call puts
  add esp, 4           ; Clear stack

  mov edx, 0           ; envp = NULL
  lea ecx, [ebx+4]     ; Set argv
  mov ebx, [ecx]       ; Set filename
  mov eax, 11          ; Set execve syscall
  int 0x80             ; Init syscall
end:
  leave
  ret
